#ifndef JUNOUI_H
#define JUNOUI_H

#include "UITypes.h"

UITYPES juno6ui[] =
{
    {UIBITMAP, 0, 0, 0, IDB_BACKGROUND}, // background first !!!

    //Modulator section
    {UISLIDER, 43, 185, 0, 0, "bender_dco"},
    {UISLIDER, 66, 185, 0, 0, "bender_vcf"},
    {UIBENDER, 22, 159, 0, 0, "bender"},
    {UITHREESWITCH, 94, 188, 0, 0, "octave_transpose"},
    {UIKICKBUTTON, 133, 188, 0, IDB_WHITE_BUTTON, "lfo_trigger"},

    {UIKNOB, 628, 197, 0, 0, "panning", 0.5f},
    {UIKNOB, 659, 197, 0, 0, "master_tune", 0.5f},

    //Mode section
    {UITWOSWITCH, 390, 188, 0, 0, "transpose_switch"},
    {UITWOSWITCH, 417, 188, 0, 0, "stereo_switch"},
    {UITWOSWITCH, 444, 188, 0, 0, "hold_switch"},
    {UITWOSWITCH, 471, 188, 0, 0, "unisono"},
    {UISLIDER,    501, 185, 0, 0, "unisono_detune"},

    //Phaser section
    {UISLIDER, 172, 185, 0, 0, "phaser_rate"},
    {UISLIDER, 194, 185, 0, 0, "phaser_feedback"},

    //Arpeggio section
    {UITWOSWITCH,    30, 78, 0, 0, "arpeggio_switch"},
    {UITHREESWITCH,  50, 78, 0, 0, "arpeggio_mode"},
    {UITHREESWITCH,  96, 78, 0, 0, "arpeggio_range"},
    {UISLIDER,      125, 78, 0, 0, "arpeggio_rate"},

    //LFO Section
    {UITWOSWITCH, 174, 78, 0, 0, "lfo_mode"},
    {UISLIDER,    192, 75, 0, 0, "lfo_rate"},
    {UISLIDER,    214, 75, 0, 0, "lfo_delay"},

    //DCO Section (VCO)
    {UISLIDER,      246, 75, 0, 0, "dco_lfo"},
    {UISLIDER,      268, 75, 0, 0, "dco_pwm"},
    {UITHREESWITCH, 291, 78, 0, 0, "dco_pwm_mod"},
    {UITWOSWITCH,   320, 78, 0, 0, "dco_pulse_switch"},
    {UITWOSWITCH,   338, 78, 0, 0, "dco_saw_switch"},
    {UITWOSWITCH,   356, 78, 0, 0, "dco_sub_switch"},
    {UISLIDER,      375, 75, 0, 0, "dco_sub"},
    {UISLIDER,      397, 75, 0, 0, "dco_noise"},

    //VCF Section
    {UISLIDER, 439, 75, 0, 0, "hpf_frq"},
    {UISLIDER, 461, 75, 0, 0, "vcf_frq"},
    {UISLIDER, 483, 75, 0, 0, "vcf_res"},
    {UISLIDER, 505, 75, 0, 0, "vcf_lfo"},
    {UISLIDER, 527, 75, 0, 0, "vcf_kbd"},

    //VCA Section
    {UITWOSWITCH, 570, 78, 0, 0, "vcf_env_invert"},
    {UISLIDER,    588, 75, 0, 0, "vcf_env"},
    {UITWOSWITCH, 612, 78, 0, 0, "vca_mode"},
    {UISLIDER,    630, 75, 0, 0, "volume"},
    {UISLIDER,    652, 75, 0, 0, "env_attack"},
    {UISLIDER,    674, 75, 0, 0, "env_decay"},
    {UISLIDER,    696, 75, 0, 0, "env_sustain"},
    {UISLIDER,    718, 75, 0, 0, "env_release"},

    //Reverb Section
    {UISLIDER,    236, 184, 0, 0, "reverb_wet"},
    {UISLIDER,    258, 184, 0, 0, "reverb_dry"},
    {UISLIDER,    280, 184, 0, 0, "reverb_roomsize"},
    {UISLIDER,    302, 184, 0, 0, "reverb_damp"},
    {UISLIDER,    324, 184, 0, 0, "reverb_width"},
    {UITWOSWITCH, 349, 188, 0, 0, "reverb_mode"},

    // Chorus
    {UIKICKBUTTON, 541, 198, 0, IDB_WHITE_BUTTON, "chorus_off_switch"},
    {UIBUTTON,     563, 198, 0, IDB_WHITE_BUTTON, "chorus_I_switch"},
    {UIBUTTON,     585, 198, 0, IDB_WHITE_BUTTON, "chorus_II_switch"},
    {UIBUTTON,     607, 198, 0, IDB_WHITE_BUTTON, "arpeggio_sync"},

    {UIKEYFULL,  19, 260,  0, IDB_FIRST}, //Keys
    {UIKEYFULL,  31, 260,  2, IDB_D},
    {UIKEYFULL,  55, 260,  4, IDB_E},
    {UIKEYFULL,  79, 260,  5, IDB_F},
    {UIKEYFULL,  91, 260,  7, IDB_G},
    {UIKEYFULL, 113, 260,  9, IDB_A},
    {UIKEYFULL, 135, 260, 11, IDB_B},

    {UIKEYSEMI,  31, 260,  1},
    {UIKEYSEMI,  55, 260,  3},
    {UIKEYSEMI,  91, 260,  6},
    {UIKEYSEMI, 113, 260,  8},
    {UIKEYSEMI, 135, 260, 10},

    {UIKEYFULL, 159, 260, 12, IDB_C},
    {UIKEYFULL, 171, 260, 14, IDB_D},
    {UIKEYFULL, 195, 260, 16, IDB_E},
    {UIKEYFULL, 219, 260, 17, IDB_F},
    {UIKEYFULL, 231, 260, 19, IDB_G},
    {UIKEYFULL, 253, 260, 21, IDB_A},
    {UIKEYFULL, 275, 260, 23, IDB_B},

    {UIKEYSEMI, 171, 260, 13},
    {UIKEYSEMI, 195, 260, 15},
    {UIKEYSEMI, 231, 260, 18},
    {UIKEYSEMI, 253, 260, 20},
    {UIKEYSEMI, 275, 260, 22},

    {UIKEYFULL, 299, 260, 24, IDB_C},
    {UIKEYFULL, 311, 260, 26, IDB_D},
    {UIKEYFULL, 335, 260, 28, IDB_E},
    {UIKEYFULL, 359, 260, 29, IDB_F},
    {UIKEYFULL, 371, 260, 31, IDB_G},
    {UIKEYFULL, 393, 260, 33, IDB_A},
    {UIKEYFULL, 415, 260, 35, IDB_B},

    {UIKEYSEMI, 311, 260, 25},
    {UIKEYSEMI, 335, 260, 27},
    {UIKEYSEMI, 271, 260, 30},
    {UIKEYSEMI, 393, 260, 32},
    {UIKEYSEMI, 415, 260, 34},

    {UIKEYFULL, 439, 260, 36, IDB_C},
    {UIKEYFULL, 451, 260, 38, IDB_D},
    {UIKEYFULL, 475, 260, 40, IDB_E},
    {UIKEYFULL, 499, 260, 41, IDB_F},
    {UIKEYFULL, 511, 260, 43, IDB_G},
    {UIKEYFULL, 533, 260, 45, IDB_A},
    {UIKEYFULL, 555, 260, 47, IDB_B},

    {UIKEYSEMI, 451, 260, 37},
    {UIKEYSEMI, 475, 260, 39},
    {UIKEYSEMI, 511, 260, 42},
    {UIKEYSEMI, 533, 260, 44},
    {UIKEYSEMI, 555, 260, 46},

    {UIKEYFULL, 579, 260, 48, IDB_C},
    {UIKEYFULL, 591, 260, 50, IDB_D},
    {UIKEYFULL, 615, 260, 52, IDB_E},
    {UIKEYFULL, 639, 260, 53, IDB_F},
    {UIKEYFULL, 651, 260, 55, IDB_G},
    {UIKEYFULL, 673, 260, 57, IDB_A},
    {UIKEYFULL, 695, 260, 59, IDB_B},

    {UIKEYSEMI, 591, 260, 49},
    {UIKEYSEMI, 615, 260, 51},
    {UIKEYSEMI, 651, 260, 54},
    {UIKEYSEMI, 673, 260, 56},
    {UIKEYSEMI, 695, 260, 58},

    {UIKEYFULL, 719, 260, 60, IDB_LAST},

    {UIBUTTON, 693, 198, 0, IDB_WHITE_BUTTON, "midi_learn"},
    {UIBUTTON, 722, 198, 0, IDB_WHITE_BUTTON, "midi_velocity"},

    {UIKICKBUTTON, 599, 5, 0, IDB_IMPORT_CC, "import_cc"},
    {UIKICKBUTTON, 643, 5, 0, IDB_EXPORT_CC, "export_cc"},

//    {UIABOUT, 675, 106, 0, IDB_ABOUT},

    {0, 0, 0, 0, 0, NULL} //Terminator
};

#endif
