#ifndef __UI_
#define __UI_

#include <libmoog/Control.h>
#include <libmoog/MidiInputVST.h>

#include "common/audioeffectx.h"

// FIXME !!!
#include "../libmoog/JunoControl.h"
// FIXME !!!

#include "vstgui.h"
#include "junocontrols.h"
#include "../resource/resource.h"

#include "AudioEffect.hpp"

class UI : public CControlListener, public CViewContainer, public MoogObject
{
public:
    UI(Scheduler *scheduler, ConnectionManager *connection, Control *cntrl, MidiInput *midiinput, AudioEffect *effect, CBitmap *background, int x, int y, char *name);
    ~UI();

    void addKnob(char *outputName, float defaultvalue, ParameterObjectContainer *paramcontainer);
    void addBender(char *outputName, ParameterObjectContainer *paramcontainer);
    void addButton(char *outputName, ParameterObjectContainer *paramcontainer);
    void addSlider(char *outputName, ParameterObjectContainer *paramcontainer);
    void addTwoSwitch(char *outputName, ParameterObjectContainer *paramcontainer);
    void addThreeSwitch(char *outputName, ParameterObjectContainer *paramcontainer);
    void addKickButton(char *outputName, ParameterObjectContainer *paramcontainer);

    void addFulltone(int x, int y, int key, int bmp);
    void addSemitone(int x, int y, int key);

    void drawParameters(ParameterObjectContainer *parameterObjectContainer,
                        CPoint                   *offset,     
                        long                     widthControl,
                        long                     heightControl);

    void drawBorder();

    virtual void open();

    void close();

    void valueChanged(CDrawContext *canvas, CControl *control);

    const char *getClassName()
    {
        return "Faszom";
    }

    CPoint getPosition(ParameterObjectContainer *parameterObjectContainer);
    void setPosition(ParameterObjectContainer *parameterObjectContainer, int width, int height);

    void updateControls(long tag, float value);

    float valueByType(int type, float value);


    Control *m_control;

    MidiInput *m_midiinput;

private:

    CBitmap *m_background;
    int m_maxHeight;
    int m_maxWidth;

    char *m_name;
    int  m_borderwidth;

    CPoint m_current;
    CPoint delta;

    AudioEffect *m_effect;

    // FIXME !!!
    CFulltone *prev;
    // FIXME !!!
};

#endif /* __UI_ */
