#include "UIMisc.h"

#include <libmoogutil/String.h>

void UIMisc::open()
{
    addButton("transpose_switch", new ParameterObjectContainer(
              3,

              " ",                      //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,               //Color

              "transp",                 //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,               //Color

              "  ", 
              kRight,
              kHorizontal,
              kNormalFontVerySmall,
              kWhiteCColor, 

              NULL ));

    addButton("stereo_switch", new ParameterObjectContainer(
              3,

              " ",                      //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,               //Color

              "stereo",                 //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              "  ", 
              kRight,
              kHorizontal,
              kNormalFontVerySmall,
              kBlackCColor, 

              NULL ));

    addButton("hold_switch", new ParameterObjectContainer(
              3,

              " ",                      //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,               //Color

              "hold",                   //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              "        ", 
              kRight,
              kHorizontal,
              kNormalFontVerySmall,
              kWhiteCColor, 
                       
              NULL ));

    addButton("unisono", new ParameterObjectContainer(
              3,

              "   Unisono",            //String
              kTop,                     //Position
              kLeft,                    //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              "on/off",                 //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              "  ", 
              kRight,
              kHorizontal,
              kNormalFontVerySmall,
              kBlackCColor, 

              NULL ));

    addKnob("unisono_detune", 0.5f, new ParameterObjectContainer(
              3,

              " ",                      //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              "detune",                 //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              "        ",               //String
              kRight,                     //Position
              kLeft,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              NULL ));

    addKnob("stereo_spread", 0.5f, new ParameterObjectContainer(
              3,

              " ",                      //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              "stereo spread",                 //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              "        ",               //String
              kRight,                     //Position
              kLeft,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              NULL ));

    addKnob("panning", 0.5f, new ParameterObjectContainer(
              2,

              " ",                      //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              "pan",                    //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              NULL ));

    addKnob("master_tune", 0.5f, new ParameterObjectContainer(
              3,

              " ",                      //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              "tune",                   //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              "        ",               //String
              kRight,                     //Position
              kLeft,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              NULL ));

    addButton("midi_learn", new ParameterObjectContainer(
              3,

              "     MIDI",              //String
              kTop,                     //Position
              kLeft,                    //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              "learn",                  //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              "  ", 
              kRight,
              kHorizontal,
              kNormalFontVerySmall,
              kBlackCColor, 

              NULL ));

    addButton("midi_velocity", new ParameterObjectContainer(
              3,

              " ",                      //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              " velocity",               //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              "        ",               //String
              kRight,                     //Position
              kLeft,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              NULL ));


    addKickButton("import_cc", new ParameterObjectContainer(
              3,

              "  MIDI CC",                      //String
              kTop,                     //Position
              kLeft,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              "import",               //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              "  ", 
              kRight,
              kHorizontal,
              kNormalFontVerySmall,
              kBlackCColor, 

              NULL ));

    addKickButton("export_cc", new ParameterObjectContainer(
              2,

              " ",                      //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              " export",               //String
              kTop,                     //Position
              kHorizontal,              //Align
              kNormalFontVerySmall,     //Font
              kBlackCColor,             //Color

              NULL ));
}

void UIMisc::valueChanged(CDrawContext *canvas, CControl *ccontrol)
{
    long tag = ccontrol->getTag();

    // handle open file selector for 
    if (tag == m_control->getOutputNum("import_cc") ||
        tag == m_control->getOutputNum("export_cc"))
    {
        ccontrol->update(canvas);

        AudioEffectX *effect = (AudioEffectX*)m_effect;
        if (effect && ccontrol->getValue () > 0.5f)
        {
            if (effect->canHostDo("openFileSelector"))
            {
                VstFileType juno6ctrl( "Retro6ctrl File", "r6c", "r6c");

                VstFileSelect vstFileSelect;
                memset (&vstFileSelect, 0, sizeof (VstFileType));

                if (tag == m_control->getOutputNum("open"))
                {
                    strcpy (vstFileSelect.title, "Open control presets");
                    vstFileSelect.command     = kVstFileLoad;
                }
                else
                {
                    strcpy (vstFileSelect.title, "Save control presets");
                    vstFileSelect.command     = kVstFileSave;
                }

                vstFileSelect.type        = kVstFileType;
                vstFileSelect.nbFileTypes = 1;
                vstFileSelect.fileTypes   = &juno6ctrl;
                vstFileSelect.returnPath  = new char[1024];
                vstFileSelect.initialPath = 0;

                effect->openFileSelector (&vstFileSelect);

                if (tag == m_control->getOutputNum("open"))
                    ((JunoControl*)m_control)->loadControlPreset(vstFileSelect.returnPath);
                else
                    ((JunoControl*)m_control)->saveControlPreset((String)vstFileSelect.returnPath + ".r6c");

                delete []vstFileSelect.returnPath;
            }
        }
        return;
    }

    UI::valueChanged(canvas, ccontrol);
}