#ifndef __inc_editor__
#define __inc_editor__

#ifndef __vstgui__
#include "vstgui.h"
#endif

#ifndef __audioeffectx__
#include "audioeffectx.h"
#endif

#include "UI.h"
#include "UIReverb.h"
#include "UIPhaser.h"
#include "UIArpeggio.h"
#include "UIChorus.h"
#include "UIModulator.h"
#include "UIMisc.h"
#include "UILFO.h"
#include "UIVCO.h"
#include "UIVCF.h"

#include "UIVCA.h"
#include "UIADSR.h"

#include "UIKeyboard.h"

#include <libmoog/Control.h>
#include <libmoog/MidiInputVST.h>
#include <libmoog/ConnectionManager.h>

#include "../libmoogutil/SimpleArray.h"

typedef SimpleArray <UI> UIArray;

class Editor: public AEffGUIEditor, public MoogObject
{
public:
    Editor(Scheduler *sched,ConnectionManager *conn,AudioEffect *effect, Control *cntrl, MidiInput *midiinput);
    ~Editor();

    const char *getClassName()
    {
        return "JunoEditor";
    }

    virtual void setParameter(long index, float value);

    float valueByType(int type, float value);

protected:

    virtual long open(void *ptr);
    virtual void close();

    float getParameter(long index);

private:

    MidiInput *midiInput;
    CBitmap *bmpBackground;
    Control *control;

    CControl **guiControl;

    CControl **guiKeyboard;

    CSplashScreen *aboutScreen;

    UIArray UIContainer;
};

#endif
