#pragma once

#ifndef __vstgui__
#include "vstgui.h"
#endif

//#include "vstgui.h"

#include "libmoog/ParameterObjectContainer.h"
#include "libmoog/ParameterObject.h"
#include "libmoog/Output.h"

class CFulltone : public CControl
{
public:
    CFulltone (const CRect &size, CControlListener *listener, 
               long tag, 
               long subPixmaps,        // number of subPixmaps
               long heightOfOneImage,  // pixel
               CBitmap *background, CPoint &offset);
    virtual ~CFulltone ();

    virtual void draw (CDrawContext*);
    virtual void mouse (CDrawContext *pContext, CPoint &where);
    virtual void setValue (float val);

    void setPrevKey (CFulltone *n);
    void setNextKey (CFulltone *n);

protected:
    CPoint        offset;
    long          subPixmaps;         // number of subPixmaps
    long          heightOfOneImage;
    CFulltone    *prev;
    CFulltone    *next;
};

class CSemitone : public CControl
{

public:
    CSemitone (const CRect &size, CControlListener *listener, long tag);
    virtual ~CSemitone ();
    virtual void draw (CDrawContext*);
    virtual void mouse (CDrawContext *pContext, CPoint &where);
    virtual void setValue (float val);

    void setFulltone (CFulltone *fulltone);

protected:
    CFulltone *tone;
};

class Slider : public CSlider
{
public:

    Slider(const CRect      &size,
           CControlListener *listener,
           long             tag,
           long             iMinPos,
           long             iMaxPos,
           CBitmap          *handle,
           CBitmap          *background,
           CBitmap          *sliderBackground,
           CPoint           &offset, 
           const long       style = kLeft|kHorizontal);

    Slider(const CRect      &size,
           CControlListener *listener,
           long             tag,
           CPoint           &offsetHandle,
           long             rangeHandle,
           CBitmap          *handle,
           CBitmap          *background,
           CBitmap          *sliderBackground,
           CPoint           &offset,
           const long       style = kLeft|kHorizontal);

    void draw(CDrawContext *pContext);

protected:

    CBitmap *pSliderBackground;
};

class VerticalSlider : public Slider
{
public:

    VerticalSlider (const CRect         &size, 
                    CControlListener    *listener, 
                    long                tag, 
                    long                iMinPos,
                    long                iMaxPos,
                    CBitmap             *handle, 
                    CBitmap             *background,
                    CBitmap             *sliderBackground,
                    CPoint              &offset,
                    const long          style = kBottom);

    VerticalSlider (const CRect         &rect, 
                    CControlListener    *listener, 
                    long                tag,
                    CPoint              &offsetHandle,
                    long                rangeHandle,
                    CBitmap             *handle,
                    CBitmap             *background,
                    CBitmap             *sliderBackground,
                    CPoint              &offset,
                    const long          style = kBottom);
};
