/*
 * Copyright(c) 2000 UltraMaster Group
 *
 * License to use UltraMaster Juno-6 is provided free of charge subject to the
 * following restrictions:
 *
 * 1.) This license is for your personal use only.
 *
 * 2.) No portion of this software may be redistributed by you to any other
 *     person in any form.
 *
 * 3.) You may not sell UltraMaster Juno-6 to any person.
 *
 * 4.) UltraMaster Juno-6 is provided without any express or implied warranty.
 *     In no event shall UltraMaster Group be held liable for any damages
 *     arising from the use of UltraMaster Juno-6.
 */
/**
 * Copyright (c) UltraMaster Group, LLC. All Rights Reserved.
 * $Revision: 1.12 $$Date: 2005/05/03 10:39:19 $
 */
#ifndef BALANCE_H
#define BALANCE_H

#include "MoogObject.h"
#include "Rms.h"

class Rms;

#define I_BAL_SIG1 0
#define I_BAL_SIG2 1
#define O_BAL_SIG  0
#define BALANCE_TYPE 17
class Balance: public MoogObject
{
protected:
	float *output;

	float power1_c1;
	float power1_c2;
	float power1_q;



	float power2_c1;
	float power2_c2;
	float power2_q;

	float *powinSig;
	float *inSig;

public:
	Balance(Scheduler *sched);
	~Balance();

	//override because Rms has special handling and we've borrowed
	//its inputs
	void connectTo(ConnectionInfo *info);
	void disconnectTo(ConnectionInfo *info);

	void updateSampleRate();
	float sig, power1, power2;
	void INLINE sampleGo()
	{
		sig = *inSig;
		power1_q = power1_c1 * *powinSig * *powinSig + power1_c2 * power1_q;
		power2_q = power2_c1 * sig * sig + power2_c2 * power2_q;
		if (power1_q < 0.0f)
			power1_q = 0;
		if (power2_q < 0.0f)
			power2_q = 0;
		UNDENORMAL(power1_q);
		UNDENORMAL(power2_q);

		power1 = fastsqrt(power1_q);
		power2 = fastsqrt(power2_q);
		if (power1 < -1.0f || power1 > 1.0f)
		{
			*output = 0.0f;
			return;

		}


		if (power2 == 0.0f || power2 < -1.0f || power2 > 1.0f)
			*output = 0.0f;
		else

			*output = sig * (power1 / power2);
	}

	const char *getClassName()
	{
		return "Balance";
	}
};

#endif /* BALANCE_H */
