/*
 * Copyright(c) 2000 UltraMaster Group
 *
 * License to use UltraMaster Juno-6 is provided free of charge subject to the
 * following restrictions:
 *
 * 1.) This license is for your personal use only.
 *
 * 2.) No portion of this software may be redistributed by you to any other
 *     person in any form.
 *
 * 3.) You may not sell UltraMaster Juno-6 to any person.
 *
 * 4.) UltraMaster Juno-6 is provided without any express or implied warranty.
 *     In no event shall UltraMaster Group be held liable for any damages
 *     arising from the use of UltraMaster Juno-6.
 */
#include <stdio.h>
#include <stdlib.h>
//#include <libmoogutil/debug.h>
//#include <libmoogutil/rcsid.h>
#include "GoObject.h"
#include "Scheduler.h"

//RCSID("$Id: GoObject.cpp,v 1.12 2005/05/03 10:40:49 brainslayer Exp $");



#include "MoogObject.h"


float *sqrttable;
static bool sqisinit = false;
void initsqrt(void)
{
	if (sqisinit == true)
		return;
	sqisinit = true;
	sqrttable = new float[65536];
	for (int i = 0;i < 65536;i++)
	{
		float sq = (float)i;
		sqrttable[i] = sqrtf(sq / 65536);
	}
}

GoObject::GoObject(int t, Scheduler *sched)
{
	type = t;
	schedule = sched;
	on = false;
	goHandle = schedule->nextGoHandle++;
}

#ifndef VERBOSE
void GoObject::SampleOn()
{
	schedule->scheduleSampleRate(this, true);
}

void GoObject::SampleOff()
{
	schedule->scheduleSampleRate(this, false);
}
void GoObject::ControlOn()
{
	schedule->scheduleControlRate(this, true);
}

void GoObject::ControlOff()
{
	schedule->scheduleControlRate(this, false);
}
#else
void GoObject::SampleOn(MoogObject *ident)
{
	FILE *verbose = fopen("c:\\debug.verbose", "a+");
	fprintf(verbose, "sampleOn() %s by %s\n", ((MoogObject *)this)->getClassName(), ident->getClassName());
	fclose(verbose);

	schedule->scheduleSampleRate(this, true);
}

void GoObject::SampleOff(MoogObject *ident)
{
	FILE *verbose = fopen("c:\\debug.verbose", "a+");
	fprintf(verbose, "sampleOff() %s by %s\n", ((MoogObject *)this)->getClassName(), ident->getClassName());
	fclose(verbose);
	schedule->scheduleSampleRate(this, false);
}
void GoObject::ControlOn(MoogObject *ident)
{
	FILE *verbose = fopen("c:\\debug.verbose", "a+");
	fprintf(verbose, "controlOn() %s by %s\n", ((MoogObject *)this)->getClassName(), ident->getClassName());
	fclose(verbose);
	schedule->scheduleControlRate(this, true);
}

void GoObject::ControlOff(MoogObject *ident)
{
	FILE *verbose = fopen("c:\\debug.verbose", "a+");
	fprintf(verbose, "controlOff() %s by %s\n", ((MoogObject *)this)->getClassName(), ident->getClassName());
	fclose(verbose);
	schedule->scheduleControlRate(this, false);
}
#endif
