/*
 * Copyright(c) 2000 UltraMaster Group
 *
 * License to use UltraMaster Juno-6 is provided free of charge subject to the
 * following restrictions:
 *
 * 1.) This license is for your personal use only.
 *
 * 2.) No portion of this software may be redistributed by you to any other
 *     person in any form.
 *
 * 3.) You may not sell UltraMaster Juno-6 to any person.
 *
 * 4.) UltraMaster Juno-6 is provided without any express or implied warranty.
 *     In no event shall UltraMaster Group be held liable for any damages
 *     arising from the use of UltraMaster Juno-6.
 */
/**
 * Copyright (c) UltraMaster Group, LLC. All Rights Reserved.
 * $Revision: 1.16 $$Date: 2005/05/03 10:40:55 $
 */
#ifndef _GOOBJECT_H
#define _GOOBJECT_H

#include <math.h>
#include <libmoogutil/list.h>
#include <libmoogutil/SimpleArray.h>

extern float *sqrttable;
extern void initsqrt(void);

static __forceinline float fastsqrt(float sq)
{
	if (sq < 0.0f)
		return 0.0f;
	if (sq > 1.0f)
		return 1.0f;
	return sqrttable[(int)(sq*65536)];
}

#define TOBOOL(a) a>0.0f?true:false
/* $Id: GoObject.h,v 1.16 2005/05/03 10:40:55 brainslayer Exp $ */

#define UNDENORMAL(sample) if(((*(unsigned int*)&sample)&0x7f800000)==0) sample=0.0f
/*
__inline void UNDENORMAL(float &val)
{
const int x = *reinterpret_cast <const int *> (&val); // needs 32-bit int
const int abs_mantissa = x & 0x007FFFFF;
const int biased_exponent = x & 0x7F800000;
if (biased_exponent == 0 && abs_mantissa != 0)
{
val = 0;
}
}*/
#ifndef INLINE
#define INLINE __forceinline
#endif
class GoObject
{
	friend class Scheduler;
#ifdef VERBOSE
	friend class MoogObject;
#endif

	int nextGoHandle;

protected:
	GoObject()
	{
	}
	virtual ~GoObject()
	{
	}
	int goHandle;



public:
	bool on;
	bool updateon;
	int type;
	Scheduler *schedule;
	GoObject(int type, Scheduler *schedule);
#ifndef VERBOSE
	void SampleOn();
	void SampleOff();
	void ControlOn();
	void ControlOff();
#else
	void SampleOn(MoogObject *);
	void SampleOff(MoogObject *);
	void ControlOn(MoogObject *);
	void ControlOff(MoogObject *);
#endif
};

#endif /* _GOOBJECT_H */

