/*
 * Copyright(c) 2000 UltraMaster Group
 *
 * License to use UltraMaster Juno-6 is provided free of charge subject to the
 * following restrictions:
 *
 * 1.) This license is for your personal use only.
 *
 * 2.) No portion of this software may be redistributed by you to any other
 *     person in any form.
 *
 * 3.) You may not sell UltraMaster Juno-6 to any person.
 *
 * 4.) UltraMaster Juno-6 is provided without any express or implied warranty.
 *     In no event shall UltraMaster Group be held liable for any damages
 *     arising from the use of UltraMaster Juno-6.
 */
#ifndef _LIBMOOG_HPF_H
#define _LIBMOOG_HPF_H

#include "IIR2.h"
#include "../libmoogutil/valuehelper.h"

#ifndef M_PI
#define M_PI		(float)3.14159265358979323846
#endif
#define HPF_TYPE 14
class HPF: public IIR2
{
	friend void HPF_frqChanged(MoogObject *o, float data, long userData);
	friend void HPF_QChanged(MoogObject *o, float data, long userData);

	float frq;
	float Q;
	float newfrq;
	float newQ;

	void INLINE frqChanged(float data)
	{
		newfrq = data;
		updateCoef();
	}
	void INLINE QChanged(float data)
	{
		newQ = data;
		updateCoef();
	};





public:
	void INLINE updateCoef();
	void INLINE sampleGo()
	{
		bool ch = false;
		ch |= processParameter(&Q, newQ, 0.0001f);
		ch |= processParameter(&frq, newfrq, 0.0001f);
		if (ch)
			updateCoef();
		IIR2::sampleGo();
	}
	HPF(Scheduler *sched);
	const char *getClassName()
	{
		return "HPF";
	}
};


#endif /* _LIBMOOG_HPF_H */
