/*
 * Copyright(c) 2000 UltraMaster Group
 *
 * License to use UltraMaster Juno-6 is provided free of charge subject to the
 * following restrictions:
 *
 * 1.) This license is for your personal use only.
 *
 * 2.) No portion of this software may be redistributed by you to any other
 *     person in any form.
 *
 * 3.) You may not sell UltraMaster Juno-6 to any person.
 *
 * 4.) UltraMaster Juno-6 is provided without any express or implied warranty.
 *     In no event shall UltraMaster Group be held liable for any damages
 *     arising from the use of UltraMaster Juno-6.
 */
#ifndef _LIBMOOG_IIR2_H
#define _LIBMOOG_IIR2_H

#include "MoogObject.h"

class IIR2: public MoogObject
{
	float *in;
	Output *output;

protected:
	float gain;
	float cx[2];
	float cy[2];
	float x[2];
	float y[2];

public:
	IIR2(int type, Scheduler *sched);

	void connectTo(ConnectionInfo *);
	void disconnectTo(ConnectionInfo *);
	#define denormal_fix  0.00000001
	void INLINE sampleGo()
	{
		float out = gain * *in;
		out = out + cx[0] * x[0] + cx[1] * x[1] - cy[0] * y[0] - cy[1] * y[1]; //+ denormal_fix;
		UNDENORMAL(out);
		x[1] = x[0];
		x[0] = *in;

		y[1] = y[0];
		y[0] = out;

		output->data = out;
	}


	const char *getClassName()
	{
		return "IIR2";
	}
};

#endif /* _LIBMOOG_IIR2_H */
