/*
 * Copyright(c) 2000 UltraMaster Group
 *
 * License to use UltraMaster Juno-6 is provided free of charge subject to the
 * following restrictions:
 *
 * 1.) This license is for your personal use only.
 *
 * 2.) No portion of this software may be redistributed by you to any other
 *     person in any form.
 *
 * 3.) You may not sell UltraMaster Juno-6 to any person.
 *
 * 4.) UltraMaster Juno-6 is provided without any express or implied warranty.
 *     In no event shall UltraMaster Group be held liable for any damages
 *     arising from the use of UltraMaster Juno-6.
 */
/**
 * Copyright (c) UltraMaster Group, LLC. All Rights Reserved.
 * $Revision: 1.4 $$Date: 2004/12/16 15:12:35 $
 */
#ifndef JUNO_CHORUS_H
#define JUNO_CHORUS_H

#include "MoogObject.h"
#include "Chorus.h"
#include "Mixer.h"
#include "ConnectionManager.h"
#include "Scheduler.h"
#define CHORUS_TYPE 13
class JunoChorus: public MoogObject
{
private:
	friend void JunoChorus_offChanged(MoogObject *, float, long);
	friend void JunoChorus_IChanged(MoogObject *, float, long);
	friend void JunoChorus_IIChanged(MoogObject *, float, long);

	void INLINE offChanged(float value);
	void INLINE IChanged(float value);
	void INLINE IIChanged(float value);

	Chorus c1;
	Chorus c2;
	Mixer m;

	bool oneOn, twoOn;

public:
	JunoChorus(MoogObject *src, const char *outputName, int phase);
	~JunoChorus();
	const char *getClassName()
	{
		return ("JunoChorus");
	}
};

#endif /* JUNO_CHORUS_H */
