/*
 * Copyright(c) 2000 UltraMaster Group
 *
 * License to use UltraMaster Juno-6 is provided free of charge subject to the
 * following restrictions:
 *
 * 1.) This license is for your personal use only.
 *
 * 2.) No portion of this software may be redistributed by you to any other
 *     person in any form.
 *
 * 3.) You may not sell UltraMaster Juno-6 to any person.
 *
 * 4.) UltraMaster Juno-6 is provided without any express or implied warranty.
 *     In no event shall UltraMaster Group be held liable for any damages
 *     arising from the use of UltraMaster Juno-6.
 */
/**
 * Copyright (c) UltraMaster Group, LLC. All Rights Reserved.
 * $Revision: 1.9 $$Date: 2004/12/16 15:12:35 $
 */
#ifndef JUNO_CONTROL_H
#define JUNO_CONTROL_H

#include "MoogObject.h"
#include "Control.h"
#include <libmoog/JunoPatch.h>
//#include <libmoogutil/String.h>
#define JUNOCONTROL_TYPE 20
class JunoControl: public Control
{
	juno_patch *patches;
	float curbpm;
	friend void controlmap(MoogObject *, float, long);
	friend void control_savestate(MoogObject *, float, long);
	friend void learn(MoogObject *, float, long);
	bool learning;
	void INLINE controlMapping(float, long);
	void INLINE savestate(float, long);
	void INLINE midilearn(float, long);
	int *mappings;
	int lastoutput;
public:

	bool loadSysEx(const char *name, int patch);
	bool saveSysEx(const char *name, int patch);
	bool loadControlPreset(const char *name);
	bool saveControlPreset(const char *name);

	JunoControl(int, juno_patch *p, Scheduler *sched);
	const char *getClassName()
	{
		return "JunoControl";
	}
};

#endif /* JUNO_CONTROL_H */



