/*
 * Copyright(c) 2000 UltraMaster Group
 *
 * License to use UltraMaster Juno-6 is provided free of charge subject to the
 * following restrictions:
 *
 * 1.) This license is for your personal use only.
 *
 * 2.) No portion of this software may be redistributed by you to any other
 *     person in any form.
 *
 * 3.) You may not sell UltraMaster Juno-6 to any person.
 *
 * 4.) UltraMaster Juno-6 is provided without any express or implied warranty.
 *     In no event shall UltraMaster Group be held liable for any damages
 *     arising from the use of UltraMaster Juno-6.
 */
#ifndef _JUNO6_JUNO6_LFO_H
#define _JUNO6_JUNO6_LFO_H

#include <libmoog/MoogObject.h>
#include <libmoog/SawLfo.h>

class Control;

#define LFO_TYPE 12

class JunoLfo: public MoogObject
{
    friend void JunoLfo_lforateChanged(MoogObject *, float, long);
    friend void JunoLfo_lfodelayChanged(MoogObject *, float, long);
    friend void JunoLfo_lfomodeChanged(MoogObject *, float, long);
    friend void JunoLfo_lfotriggerChanged(MoogObject *, float, long);
    friend void JunoLfo_voicegateChanged(MoogObject *, float, long);

    SawLfo osc;

    float lforate;
    float lfodelay;
    int lfomode;
    int lfotrigger;
    int voicegate;

    int trigger;
    float lfoamp;

    INLINE void lforateChanged(float);
    INLINE void lfodelayChanged(float);
    INLINE void lfomodeChanged(bool);
    INLINE void lfotriggerChanged(bool);
    INLINE void voicegateChanged(int, bool);

    void INLINE checkTrigger();

public:
    JunoLfo(Control *, int, Scheduler *sched, ConnectionManager *conn);
    ~JunoLfo();

    void INLINE controlGo()
    {
        lfoamp += lfodelay;

        if (lfoamp >= 1.0)
        {
            osc.set("amp", 1.0f);

#ifdef VERBOSE
            ControlOff(this);
#else
            ControlOff();
#endif
        }
        else
        {
            osc.set("amp", lfoamp);
        }
    }

    const char *getClassName()
    {
        return "JunoLfo";
    }
};

#endif /* _JUNO6_JUNO6_LFO_H */
