/*
 * Copyright(c) 2000 UltraMaster Group
 *
 * License to use UltraMaster Juno-6 is provided free of charge subject to the
 * following restrictions:
 *
 * 1.) This license is for your personal use only.
 *
 * 2.) No portion of this software may be redistributed by you to any other
 *     person in any form.
 *
 * 3.) You may not sell UltraMaster Juno-6 to any person.
 *
 * 4.) UltraMaster Juno-6 is provided without any express or implied warranty.
 *     In no event shall UltraMaster Group be held liable for any damages
 *     arising from the use of UltraMaster Juno-6.
 */
/**
 * Copyright (c) UltraMaster Group, LLC. All Rights Reserved.
 * $Revision: 1.13 $$Date: 2005/02/25 15:48:51 $
 */
#ifndef _MIXER_H
#define _MIXER_H

#include "MoogObject.h"
#include <math.h>

#define O_MIX_SIG 0

#define I_MIX_AMP(x) (3 * (x))
#define I_MIX_SIG(x) (3 * (x) + 1)
#define I_MIX_PAN(x) (3 * (c) + 2);

#define MIXER_TYPE 0x7

class Mixer: public MoogObject
{
private:
    int numChannels;
    void init(int);
    Output *outputleft;
    Output *outputright;

    float **inputData;
    bool m_haspan;

public:
    Mixer(Scheduler *sched, ConnectionManager *conn, int n, bool haspan, int obj = 0, ...);
    ~Mixer();

    void connectTo(ConnectionInfo *info);
    void disconnectTo(ConnectionInfo *info);

    void INLINE sampleGo()
    {

        if (m_haspan)
        {
            register int i = numChannels * 3;
            float leftdata = 0;
            float rightdata = 0;
            while (i > 0)
            {
                i--;
/*
                UNDENORMAL(*inputData[i-1]);
                UNDENORMAL(*inputData[i-2]);
*/
                float t = *inputData[i-1] * *inputData[i-2];
                leftdata += t * *inputData[i];
                rightdata += t * (1.0f - *inputData[i]);

                i -= 2;
            }
            outputleft->data = leftdata;
            outputright->data = rightdata;
        }
        else
        {
            register int i = numChannels * 3;
            float tmpdata = 0;

            while (i > 0)
            {
                i -= 2;
/*
                UNDENORMAL(*inputData[i]);
                UNDENORMAL(*inputData[i-1]);
*/
                tmpdata += *inputData[i] * *inputData[i-1];

                i--;
            }
            outputleft->data = tmpdata;
        }
    }

    const char *getClassName()
    {
        return "Mixer";
    }
};

#endif /* _MIXER_H */


