/*
 * Copyright(c) 2000 UltraMaster Group
 *
 * License to use UltraMaster Juno-6 is provided free of charge subject to the
 * following restrictions:
 *
 * 1.) This license is for your personal use only.
 *
 * 2.) No portion of this software may be redistributed by you to any other
 *     person in any form.
 *
 * 3.) You may not sell UltraMaster Juno-6 to any person.
 *
 * 4.) UltraMaster Juno-6 is provided without any express or implied warranty.
 *     In no event shall UltraMaster Group be held liable for any damages
 *     arising from the use of UltraMaster Juno-6.
 */
/**
 * Copyright (c) UltraMaster Group, LLC. All Rights Reserved.
 * $Revision: 1.17 $$Date: 2004/12/16 15:12:35 $
 */
#ifndef _OUTPUT_H
#define _OUTPUT_H

#ifndef INLINE
#define INLINE __forceinline
#endif

#include <libmoogutil/SimpleArray.h>
#include "ConnectionList.h"
#include "NamedObject.h"
#include "Input.h"
#include "ConnectionInfo.h"

//#include "../VSTi/common/vstgui.h"

class Output: public NamedObject
{
	ConnectionList connections;
	bool hasEventInputs;
	bool continuousOutput;
	int type; //just normal
	MoogObject *owner;

public:

	Output(MoogObject *obj,
		const char *name,
		bool _continuousOutput);

	Output(MoogObject *obj,
		const char *name,
		const char *displayname,
		bool _continuousOutput);

	Output(MoogObject *obj,
		const char *name,
		const char *displayname,
		int _type,
		bool _continuousOutput);

	void connect(ConnectionInfo *);
	void disconnect(ConnectionInfo *);

	int INLINE getType()
	{
		return type;
	}

	float INLINE *getData()
	{
		return &data;
	}

	float data;

	ConnectionList *getConnections()
	{
		return &connections;
	}

#ifdef VERBOSE
	INLINE void setData(float data);
#else
	INLINE void setData(float _data)
	{
		data = _data;

		if (hasEventInputs)
		{
			ConnectionInfo *info;

			//FIXME: is this thread safe???
			connections.resetIterator();
			info = connections.getNextConnection();
			while (info)
			{
				if (!continuousOutput ||
					++info->input->currentTimeout == info->input->timescale)
				{
					info->input->doCallback(data);
				}
				info = connections.getNextConnection();
			}
		}

	}
#endif

};

typedef SimpleArray <Output >OutputArray;

#endif /* _OUTPUT_H */
