#include "ParameterObjectContainer.h"

ParameterObjectContainer::ParameterObjectContainer(int numObjects, ...):
m_parameterobjectnum(numObjects)
{
	m_parameterobject = new ParameterObject *[numObjects];

	va_list ap;
	va_start(ap, numObjects);

	for (int i = 0;i < numObjects;i++)
	{
		const char *str = va_arg(ap, const char *);
		CControlEnum pos = va_arg(ap, CControlEnum);
		CControlEnum aln = va_arg(ap, CControlEnum);
		CFont fnt = va_arg(ap, CFont);
		CColor col = va_arg(ap, CColor);

		m_parameterobject[i] = new ParameterObject(str, pos, aln, fnt, col);
	}

	va_end(ap);
}

ParameterObjectContainer::~ParameterObjectContainer()
{
}

int ParameterObjectContainer::getParameterObjectNum()
{
	return m_parameterobjectnum;
}

ParameterObject *ParameterObjectContainer::getParameterObject(int parameter)
{
	return m_parameterobject[parameter];
}

int ParameterObjectContainer::getHeight(CFrame *pFrame, CControlEnum position)
{
	void *SystemWindow = pFrame->getSystemWindow();
	void *SystemContext = GetDC((HWND)SystemWindow);
	void *pSystemContext = CreateCompatibleDC((HDC)SystemContext);

	CDrawContext *pContext = new CDrawContext(pFrame, pSystemContext, NULL);

	int height = 0;

	for (int param = 0;param < getParameterObjectNum();param++)
	{
		ParameterObject *parameter = getParameterObject(param);

		if (parameter->getPosition() == position)
		{
			pContext->setFont(parameter->getFont());

			height += pContext->getStringHeight(parameter->getString());
		}
	}

	delete pContext;

	return height;
}

int ParameterObjectContainer::getWidth(CFrame *pFrame, CControlEnum position)
{
	void *SystemWindow = pFrame->getSystemWindow();
	void *SystemContext = GetDC((HWND)SystemWindow);
	void *pSystemContext = CreateCompatibleDC((HDC)SystemContext);

	CDrawContext *pContext = new CDrawContext(pFrame, pSystemContext, NULL);

	int width = 0;

	for (int param = 0;param < getParameterObjectNum();param++)
	{
		ParameterObject *parameter = getParameterObject(param);

		if (parameter->getPosition() == position)
		{
			pContext->setFont(parameter->getFont());

			int tmpWidth = pContext->getStringWidth(parameter->getString());

			if (tmpWidth > width)
			{
				width = tmpWidth;
			}
		}
	}

	delete pContext;

	return width;
}
