#include "Phaser.h"

void
phaser_frequency_changed(MoogObject *o, float data, long)
{
	Phaser *p = (Phaser *)o;
	//p->setup(data,*p->m_dblMinRange,*p->m_dblMaxRange,*p->m_dblRate,*p->m_dblFeedback,*p->m_dblDepth);
}

void
phaser_minrange_changed(MoogObject *o, float data, long)
{
	Phaser *p = (Phaser *)o;
}

void
phaser_maxrange_changed(MoogObject *o, float data, long)
{
	Phaser *p = (Phaser *)o;
}

void
phaser_rate_changed(MoogObject *o, float data, long)
{
	Phaser *p = (Phaser *)o;
	p->setup(p->m_dblMinRange, p->m_dblMaxRange, data, p->m_dblFeedback, p->m_dblDepth);

}

void
phaser_feedback_changed(MoogObject *o, float data, long)
{
	Phaser *p = (Phaser *)o;
	p->setup(p->m_dblMinRange, p->m_dblMaxRange, p->m_dblRate, data, p->m_dblDepth);
}

void
phaser_depth_changed(MoogObject *o, float data, long)
{
	Phaser *p = (Phaser *)o;
}

void phaser_lfo_sync(MoogObject *o, float data, long)
{
	((Phaser *)o)->lfoSync(data);
}

Phaser::Phaser(MoogObject *inputobject, const char *inputname): MoogObject(PHASER_TYPE, inputobject->schedule, inputobject->getConnectionManager())
{
	//signal routing
	addInput("sig", NULL, 0, 0);
	output = addOutput("sig", true);
	//parameter
	addInput("frequency", phaser_frequency_changed, 0, 1);
	addInput("lfosync", phaser_lfo_sync, 0, 1);
	addInput("rate", phaser_rate_changed, 0, 1);
	addInput("feedback", phaser_feedback_changed, 0, 1);
	//addInput("depth",phaser_depth_changed,0,1);
	setup(440.0f, 1600.0f, 0.5f, 0.7f, 1.0f);
	PATCH(inputobject, inputname, this, "sig");

#ifdef VERBOSE
	SampleOn(this);
#else
	SampleOn();
#endif

	_zm1 = 0;
	_lfoPhase = 0.0;
}

Phaser::~Phaser(void)
{

}

void Phaser::connectTo(ConnectionInfo *info)
{
	MoogObject::connectTo(info);
	inSig = inputs[0].data;
}

void Phaser::disconnectTo(ConnectionInfo *info)
{
	MoogObject::disconnectTo(info);
	inSig = inputs[0].data;
}

void Phaser::setup(float minrange, float maxrange, float rate, float feedback, float depth)
{
	m_dblFrequency = (float)schedule->sampleRate;
	m_dblMinRange = minrange;
	m_dblMaxRange = maxrange;
	m_dblRate = rate;
	m_dblFeedback = feedback;
	m_dblDepth = depth;

	_dmin = minrange / (m_dblFrequency / 2.f);
	_dmax = maxrange / (m_dblFrequency / 2.f);
	_lfoInc = 2.f * M_PI * (rate / m_dblFrequency);
	_fb = feedback;
	_depth = depth;
}

void Phaser::lfoSync(float data)
{
	_lfoPhase = 0.0f;
}
