/*
 * Copyright(c) 2000 UltraMaster Group
 *
 * License to use UltraMaster Juno-6 is provided free of charge subject to the
 * following restrictions:
 *
 * 1.) This license is for your personal use only.
 *
 * 2.) No portion of this software may be redistributed by you to any other
 *     person in any form.
 *
 * 3.) You may not sell UltraMaster Juno-6 to any person.
 *
 * 4.) UltraMaster Juno-6 is provided without any express or implied warranty.
 *     In no event shall UltraMaster Group be held liable for any damages
 *     arising from the use of UltraMaster Juno-6.
 */
#include <stdlib.h>
#include <math.h>
#include "Rand.h"
#include "Scheduler.h"

void Rand_freqChanged(MoogObject *o, float data, long)
{
	((Rand *)o)->freqChanged(data);
}

Rand::Rand(Scheduler *sched, int _type, float amp): MoogObject(RAND_TYPE, sched, NULL)
{
	addPorts("frq", INPUT, Rand_freqChanged, 1, 0,
		"amp", INPUT, NULL,
		"zro", INPUT, NULL,
		"sig", OUTPUT, true,
		NULL);

	output = &outputs[O_RND_SIG];
	inFrq = inputs[0].data;
	inAmp = inputs[1].data;
	inZro = inputs[2].data;

	type = _type;
	last = (2.0f * rand() / RAND_MAX) - 1.0f;
	current = (2.0f * rand() / RAND_MAX) - 1.0f;
	pos = 0;

	set(I_RND_AMP, amp);
#ifdef VERBOSE
	SampleOn(this);
#else
	SampleOn();
#endif
}

void Rand::connectTo(ConnectionInfo *info)
{
	MoogObject::connectTo(info);
	inFrq = inputs[0].data;
	inAmp = inputs[1].data;
	inZro = inputs[2].data;
}

void Rand::disconnectTo(ConnectionInfo *info)
{
	MoogObject::disconnectTo(info);
	inFrq = inputs[0].data;
	inAmp = inputs[1].data;
	inZro = inputs[2].data;
}


void
Rand::freqChanged(float data)
{
	step = fabs(data);
}

