#pragma once

#include <libmoog/MoogObject.h>
#include <libmoog/ConnectionManager.h>
#include <libmoog/Scheduler.h>
#include <libmoog/reverb/comb.hpp>
#include <libmoog/reverb/allpass.hpp>
#include <libmoog/reverb/tuning.h>

#define REVERB_TYPE 0x3
class Reverb: public MoogObject
{
public:



	Reverb(Scheduler *sched, ConnectionManager *mgr);
	void			mute();
	//void	processmix(float *inputL, float *inputR, float *outputL, float *outputR, long numsamples, int skip);
	void		sampleGo(float *input, float *input2, int len); //float *inputL, float *inputR, float *outputL, float *outputR, long numsamples, int skip);
	void		INLINE	setroomsize(float value);
	float		INLINE	getroomsize();
	void		INLINE	setdamp(float value);
	float		INLINE	getdamp();
	void		INLINE	setwet(float value);
	float		INLINE	getwet();
	void		INLINE	setdry(float value);
	float		INLINE	getdry();
	void		INLINE	setwidth(float value);
	float		INLINE	getwidth();
	void		INLINE	setmode(float value);
	float		INLINE	getmode();
	void connectTo(ConnectionInfo *info);
	void disconnectTo(ConnectionInfo *info);

	const char *getClassName()
	{
		return "Reverb";
	}
private:
	void			update();
private:
	float	gain;
	float	roomsize, roomsize1;
	float	damp, damp1;
	float	wet, wet1, wet2;
	float	dry;
	float	width;
	float	mode;

	// The following are all declared inline
	// to remove the need for dynamic allocation
	// with its subsequent error-checking messiness

	// Comb filters
	comb	combL[numcombs];
	comb	combR[numcombs];

	// Allpass filters
	allpass	allpassL[numallpasses];
	allpass	allpassR[numallpasses];

	// Buffers for the combs
	float	bufcombL1[combtuningL1];
	float	bufcombR1[combtuningR1];
	float	bufcombL2[combtuningL2];
	float	bufcombR2[combtuningR2];
	float	bufcombL3[combtuningL3];
	float	bufcombR3[combtuningR3];
	float	bufcombL4[combtuningL4];
	float	bufcombR4[combtuningR4];
	float	bufcombL5[combtuningL5];
	float	bufcombR5[combtuningR5];
	float	bufcombL6[combtuningL6];
	float	bufcombR6[combtuningR6];
	float	bufcombL7[combtuningL7];
	float	bufcombR7[combtuningR7];
	float	bufcombL8[combtuningL8];
	float	bufcombR8[combtuningR8];

	// Buffers for the allpasses
	float	bufallpassL1[allpasstuningL1];
	float	bufallpassR1[allpasstuningR1];
	float	bufallpassL2[allpasstuningL2];
	float	bufallpassR2[allpasstuningR2];
	float	bufallpassL3[allpasstuningL3];
	float	bufallpassR3[allpasstuningR3];
	float	bufallpassL4[allpasstuningL4];
	float	bufallpassR4[allpasstuningR4];

};
