/*
 * Copyright(c) 2000 UltraMaster Group
 *
 * License to use UltraMaster Juno-6 is provided free of charge subject to the
 * following restrictions:
 *
 * 1.) This license is for your personal use only.
 *
 * 2.) No portion of this software may be redistributed by you to any other
 *     person in any form.
 *
 * 3.) You may not sell UltraMaster Juno-6 to any person.
 *
 * 4.) UltraMaster Juno-6 is provided without any express or implied warranty.
 *     In no event shall UltraMaster Group be held liable for any damages
 *     arising from the use of UltraMaster Juno-6.
 */
#include <math.h>
#include "Rms.h"
#include "Scheduler.h"

Rms::Rms(Scheduler *sched): MoogObject(RMS_TYPE, sched, NULL)
{
	addPorts("sig", INPUT, NULL,
		"pow", OUTPUT, true,
		NULL);

	output = &outputs[O_RMS_POWER];

	updateSampleRate();

	inSig = inputs[0].data;

	#ifdef VERBOSE
	SampleOn(this);
#else
	SampleOn();
#endif
	schedule->addToChangeList(this);
}
void Rms::updateSampleRate()
{

	float b;
	float twoPiDivSampleRate = 2 * M_PI / schedule->sampleRate;
	float halfPower = 10;

	b = 2.0f - cosf(halfPower * twoPiDivSampleRate);
	c2 = b - sqrtf(b * b - 1.0f);
	c1 = 1.0f - c2;
	q = 0.0f;
}
void Rms::connectTo(ConnectionInfo *info)
{
	MoogObject::connectTo(info);
	inSig = inputs[0].data;
}

void Rms::disconnectTo(ConnectionInfo *info)
{
	MoogObject::disconnectTo(info);
	inSig = inputs[0].data;
}



