/*
 * Copyright(c) 2000 UltraMaster Group
 *
 * License to use UltraMaster Juno-6 is provided free of charge subject to the
 * following restrictions:
 *
 * 1.) This license is for your personal use only.
 *
 * 2.) No portion of this software may be redistributed by you to any other
 *     person in any form.
 *
 * 3.) You may not sell UltraMaster Juno-6 to any person.
 *
 * 4.) UltraMaster Juno-6 is provided without any express or implied warranty.
 *     In no event shall UltraMaster Group be held liable for any damages
 *     arising from the use of UltraMaster Juno-6.
 */
/**
 * Copyright (c) UltraMaster Group, LLC. All Rights Reserved.
 * $Revision: 1.10 $$Date: 2004/12/25 00:25:49 $
 */
#ifndef RMS_H
#define RMS_H
#include <math.h>
#include "MoogObject.h"


#ifndef M_PI
#define M_PI		(float)3.14159265358979323846
#endif


#define I_RMS_SIG   0
#define O_RMS_POWER 0

/* use one of these two methods for calculating the rms power of a signal */
#define RMS_LOWPASS

#define RMS_TYPE 0x2
class Rms: public MoogObject
{
	Output *output;

	float c1;
	float c2;
	float q;

	float *inSig;

public:
	Rms(Scheduler *sched);

	void connectTo(ConnectionInfo *info);
	void disconnectTo(ConnectionInfo *info);

	void INLINE updateSampleRate();
	void INLINE sampleGo()
	{
		//possibly overflow problem here
		q = c1 * *inSig * *inSig + c2 * q;
		if (q < 0.0f)
			q = 0;
		output->setData(fastsqrt(q));
	}

	/* RTTI */
	const char *getClassName()
	{
		return "Rms";
	}
};

#endif /* RMS_H */
