#include <stdio.h>
#include <math.h>

#include "SawLfo.h"
#include "Scheduler.h"

void sawlfo_frq_changed(MoogObject *o, float data, long)
{
    ((SawLfo *)o)->frqChanged(data);
}

SawLfo::SawLfo(Scheduler *sched):
MoogObject(OSC_TYPE, sched, NULL)
{
    addPorts("frq", INPUT, sawlfo_frq_changed, 0, 1,
        "amp", INPUT, NULL,
        "zro", INPUT, NULL,
        "sig", OUTPUT, true,
        NULL);

    output = &outputs[O_OSC_SIG];
    inFrq = inputs[0].data;
    inAmp = inputs[1].data;
    inZro = inputs[2].data;

    rate = 0;

    phase1 = 0.f;
    phase2 = 0.1f;

#ifdef VERBOSE
    SampleOn(this);
#else
    SampleOn();
#endif

    schedule->addToChangeList(this);
}
/*
SawLfo::SawLfo(float frq, float amp = 1, float zro = 0, Scheduler *sched = NULL):
MoogObject(OSC_TYPE, sched, NULL)
{
    SawLfo(sched);

    set(I_OSC_FRQ, frq);
    set(I_OSC_AMP, amp);
    set(I_OSC_ZRO, zro);
//    schedule->addToChangeList(this);
}
*/
SawLfo::~SawLfo()
{
    schedule->removeFromChangeList(this);
}

void SawLfo::connectTo(ConnectionInfo *info)
{
    MoogObject::connectTo(info);
    inFrq = inputs[0].data;
    inAmp = inputs[1].data;
    inZro = inputs[2].data;
}

void SawLfo::disconnectTo(ConnectionInfo *info)
{
    MoogObject::disconnectTo(info);
    inFrq = inputs[0].data;
    inAmp = inputs[1].data;
    inZro = inputs[2].data;
}

void SawLfo::frqChanged(float frq)
{
    rate = frq;

    if (rate < 0.0f)
        rate = 0.0f;
}
