#ifndef _SAWLFO_H
#define _SAWLFO_H

#include "MoogObject.h"

#define I_OSC_FRQ 0
#define I_OSC_AMP 1
#define I_OSC_ZRO 2

#define O_OSC_SIG 0

#define OSC_TYPE 20

class SawLfo: public MoogObject
{
protected:
    friend void sawlfo_frq_changed(MoogObject *, float, long);

    void INLINE frqChanged(float frq);

    Output *output;
    float *inFrq;
    float *inAmp;
    float *inZro;

    float phase1;
    float phase2;
    float rate;

public:
    SawLfo(Scheduler *sched);
//    SawLfo(float frq, float amp, float zro, Scheduler *sched);
    ~SawLfo();

    /* virtual overrides */
    void connectTo(ConnectionInfo *info);
    void disconnectTo(ConnectionInfo *info);

    void INLINE sampleGo()
    {
        phase1 += rate;
        if (phase1>1) phase1 -= 2;

        phase2 += rate;
        if (phase2>1) phase2 -= 2;

        float out = (phase1*(1-abs(phase1)) - phase2*(1-abs(phase2))) * 10;

        out = out * *inAmp + *inZro;

        output->setData(out);
    }

    const char *getClassName()
    {
        return "SawLfo";
    }
};

#endif /* _SAWLFO_H */
