/*
 * Copyright(c) 2000 UltraMaster Group
 *
 * License to use UltraMaster Juno-6 is provided free of charge subject to the
 * following restrictions:
 *
 * 1.) This license is for your personal use only.
 *
 * 2.) No portion of this software may be redistributed by you to any other
 *     person in any form.
 *
 * 3.) You may not sell UltraMaster Juno-6 to any person.
 *
 * 4.) UltraMaster Juno-6 is provided without any express or implied warranty.
 *     In no event shall UltraMaster Group be held liable for any damages
 *     arising from the use of UltraMaster Juno-6.
 */
/**
 * Copyright (c) UltraMaster Group, LLC. All Rights Reserved.
 * $Revision: 1.8 $$Date: 2004/12/16 15:12:35 $
 */
#ifndef _VSTOutput_H
#define _VSTOutput_H

#include "libmoog/MoogObject.h"

#define I_DSP_SIG(n) ((n) * 2)
#define I_DSP_AMP(n) ((n) * 2 + 1)

#define SAMPLE_RATE_44k 44100
#define SAMPLE_RATE_22k 22050
#define SAMPLE_RATE_8k	 8000

#include "libmoog/Scheduler.h"
#include "libmoog/Control.h"
#include "libmoog/ConnectionManager.h"

#define VST_TYPE 0x1

class VSTOutput: public MoogObject
{
	float **inSig;
	float **inAmp;
	float panleft;
	float panright;
	int channels;

	void (*dataWrittenCallback)(void);
	void setup(double samplerate);

	float *out1;
	float *out2;

public:
	VSTOutput(Control *jc, Scheduler *sched, ConnectionManager *conn);
	~VSTOutput();

	void connectTo(ConnectionInfo *info);
	void disconnectTo(ConnectionInfo *info);
	void INLINE setPanning(float data);
	void INLINE setStereo(float data);

//    void setDataWrittenCallback(void (*)(void));
	void INLINE sampleGo()
	{
		float right = (*inSig[0] * *inAmp[0]);
		float left = (*inSig[1] * *inAmp[1]);
		if (channels == 2)
		{
			(*out1++) = (float)(right * panright);
			(*out2++) = (float)(left * panleft);
		}
		else
		{
			(*out1++) = (float)(right * panright);
			(*out2++) = (float)(right * panleft);
		}
	}
	void setOutput1(float *o1)
	{
		out1 = o1;
	}
	void setOutput2(float *o2)
	{
		out2 = o2;
	}

	/* RTTI */
	const char *getClassName()
	{
		return "VSTOutput";
	}
};

#endif /* _VSTOutput_H */
