/*
 * Copyright(c) 2000 UltraMaster Group
 *
 * License to use UltraMaster Juno-6 is provided free of charge subject to the
 * following restrictions:
 *
 * 1.) This license is for your personal use only.
 *
 * 2.) No portion of this software may be redistributed by you to any other
 *     person in any form.
 *
 * 3.) You may not sell UltraMaster Juno-6 to any person.
 *
 * 4.) UltraMaster Juno-6 is provided without any express or implied warranty.
 *     In no event shall UltraMaster Group be held liable for any damages
 *     arising from the use of UltraMaster Juno-6.
 */
/**
 * Copyright (c) UltraMaster Group, LLC. All Rights Reserved.
 * $Revision: 1.3 $$Date: 2004/09/16 20:12:23 $
 */
#ifndef WAVEGEN_H
#define WAVEGEN_H

#include "DataBlock.h"
#ifndef M_PI
#define M_PI		(float)3.14159265358979323846
#endif

DataBlock *wg_line(int size, float start, float end);
DataBlock *wg_lines(int size, int nsegs, float initial, ...);
DataBlock *wg_sin(int size, int ncoefs, ...);
DataBlock *wg_cos(int size, int ncoefs, ...);
DataBlock *wg_noise(int size);
DataBlock *wg_saw(int size);
DataBlock *wg_tri(int size);
DataBlock *wg_pow(int size, float min, float max);
DataBlock *wg_bell(int size, float sharpness);

#endif /* WAVEGEN_H */
