#ifndef __inc_limiter__
#define __inc_limiter__ __inc_limiter__

#include <math.h>

#ifdef _M_IX86
#pragma warning (disable:4244)
#endif

class Limiter
{
public:

	Limiter();
	~Limiter();

	void setRelease(float ms, float sr);
	void flush();
	void process(float &lbus);

private:

	double kRelease;

	float g;
};

inline void Limiter::process(float &lbus)
{
	lbus -= lbus * lbus * lbus * 0.16666666666666666F;

	float dg = fabs(lbus);

	if (dg < 1.f)
		dg = 1.f;
	else
		dg = 1.f / dg;

	// instant attack
	if (dg < g)
		g = dg;
	else
		g += (dg - g) * kRelease; // slow release

	lbus *= g;
};

#endif
